<?php
/*************************************************************************/
/* SPAGHETTILEARNING - E-Learning System                                 */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2004 by Emanuele Sandri (esandri@tiscali.it)            */
/*                                                                       */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/
/**
 * @module upload.php
 *
 * @version $Id: upload.php,v 1.3 2004/07/18 23:49:51 ema Exp $
 **/
require_once( dirname(__FILE__)."/../../config.php" );

$ftpConn = NULL;	// Chache for the last connection

function sl_open_fileoperations() {
	global $uploadType;
	if( $uploadType == "ftp" ) {
		return sl_open_fileoperations_ftp();
	} elseif( $uploadType == "cgi" ) {
		return TRUE;
	} else {
		return TRUE;
	}
}

function sl_close_fileoperations() {
	global $uploadType;
	if( $uploadType == "ftp" ) {
		return sl_close_fileoperations_ftp();
	} elseif( $uploadType == "cgi" ) {
		return TRUE;
	} else {
		return TRUE;
	}	
}

function sl_mkdir( $path, $mode ) {
	global $uploadType;
	if( $uploadType == "ftp" ) {
		return sl_mkdir_ftp( $path, $mode );
	} elseif( $uploadType == "cgi" ) {
		return FALSE;
	} else {
		return mkdir( $path, $mode );
	}	
}

function sl_fopen( $filename, $mode ) {
	global $uploadType;
	if( $uploadType == "ftp" ) {
		return sl_fopen_ftp( $filename, $mode );
	} elseif( $uploadType == "cgi" ) {
		return FALSE;
	} else {
		return fopen( $filename, $mode);
	}	
}

function sl_upload( $srcFile, $dstFile ) {
	global $uploadType;
	if( $uploadType == "ftp" ) {
		return sl_upload_ftp( $srcFile, $dstFile );
	} elseif( $uploadType == "cgi" ) {
		return sl_upload_cgi( $srcFile, $dstFile );
	} else {
		return sl_upload_fs( $srcFile, $dstFile );
	}
}

function sl_touch( $filename, $time ) {
	global $uploadType;
	if( $uploadType == "ftp" ) {
		return TRUE;
	} elseif( $uploadType == "cgi" ) {
		return TRUE;
	} else {
		return touch( $filename, $time );
	}
}

/** file system implementation **/

function sl_upload_fs( $srcFile, $dstFile ) {
	return move_uploaded_file($srcFile, $dstFile);
}

/** Ftp implementation **/

function sl_open_fileoperations_ftp() {
	global $ftpuser, $ftppass, $ftphost, $ftpport, $ftpConn;
	$result = FALSE;
	echo "\n<!-- +sl_open_fileoperations_ftp() -->\n";
	$ftpConn = ftp_connect( $ftphost, $ftpport );
	if( $ftpConn === FALSE ) {
		echo "\n<!-- sl_open_fileoperations_ftp ftp_connect( $ftphost, $ftpport ) returned FALSE => return FALSE -->\n";
		return FALSE;
	}
	if( @ftp_login($ftpConn, $ftpuser, $ftppass) ) 
		echo "\n<!-- -sl_open_fileoperations_ftp ftp_login($ftpConn, $ftpuser, $ftppass) returned TRUE => return TRUE -->\n";
	else
		echo "\n<!-- -sl_open_fileoperations_ftp ftp_login($ftpConn, $ftpuser, $ftppass) returned FALSE => return FALSE -->\n";
	return $ftpConn;
}

function sl_close_fileoperations_ftp() {
	global $ftpConn;
	echo "\n<!-- sl_close_fileoperations_ftp() -->\n";
	ftp_close($ftpConn);	
}

function sl_upload_ftp( $srcFile, $dstFile ) {
	global $ftppath, $ftpConn;
	echo "\n<!-- +sl_upload_ftp( $srcFile, $dstFile ) -->\n";
	if( !ftp_put( $ftpConn, $ftppath.$dstFile, $srcFile, FTP_BINARY) ) {
		echo "\n<!-- -sl_upload_ftp ftp_put( $ftpConn, $ftppath.$dstFile, $srcFile, FTP_BINARY) returned FALSE => return FALSE -->\n";
		return FALSE;
	} else {
		echo "\n<!--  sl_upload_ftp ftp_put( $ftpConn, $ftppath.$dstFile, $srcFile, FTP_BINARY) returned TRUE -->\n";
	}
	if( ftp_site( $ftpConn, "CHMOD 0666 $ftppath"."$dstFile" ) === FALSE ) {
		echo "\n<!-- -sl_upload_ftp ftp_site( $ftpConn, \"CHMOD 0666 $ftppath"."$dstFile\" ) returned FALSE => return FALSE ) -->\n";
		return FALSE;
	}	else {
		echo "\n<!-- -sl_upload_ftp ftp_site( $ftpConn, \"CHMOD 0666 $ftppath"."$dstFile\" ) returned TRUE => return TRUE ) -->\n";
		return TRUE;
	}	
	return TRUE;
}

function sl_mkdir_ftp( $path, $mode = FALSE) {
	global $ftppath, $ftpConn;
	echo "\n<!-- +sl_mkdir_ftp( $path, $mode ) -->\n";
	echo "\n<!--  sl_mkdir_ftp => create dir $ftppath"."$path -->\n";
	if( !@ftp_mkdir($ftpConn, $ftppath.$path) ) {
		echo "\n<!-- -sl_mkdir_ftp ftp_mkdir($ftpConn, $ftppath"."$path) returned FALSE => return FALSE ) -->\n";
		return FALSE;
	} else {
		echo "\n<!--  sl_mkdir_ftp ftp_mkdir($ftpConn, $ftppath"."$path) returned TRUE -->\n";
	}
	if( $mode !== FALSE ) {
		if( ftp_site( $ftpConn, "CHMOD 0777 $ftppath"."$path"  ) === FALSE ) {
			echo "\n<!-- -sl_mkdir_ftp ftp_site( $ftpConn, \"CHMOD 0777 $ftppath"."$path\"  )) returned FALSE => return FALSE ) -->\n";
			return FALSE;
		}	else {
			echo "\n<!-- -sl_mkdir_ftp mode = $mode return TRUE -->\n";
			return TRUE;
		}
	}	else {
		echo "\n<!-- -sl_mkdir_ftp mode = FALSE return TRUE -->\n";
		return TRUE;
	}
	return TRUE;
	echo "\n<!-- -sl_mkdir_ftp ???? -->\n";
}

function sl_fopen_ftp( $file, $mode ) {
	echo "<!-- +sl_fopen_ftp( $file, $mode ) -->";
	if( strstr ( $mode, "r") === FALSE ) {
		echo "\n<!--  sl_fopen_ftp mode = $mode => write -->\n";
  	// only create file then open it with fopen
  	global $ftppath, $ftpConn;
  	if( !file_exists( $file ) ) {
  		echo "\n<!--  sl_fopen_ftp file not exist => put it up -->\n";
  		if( !ftp_put( $ftpConn, $ftppath.$file, dirname(__FILE__)."/nullfile", FTP_BINARY ) ) {
  			echo "\n<!-- -sl_fopen_ftp ftp_put( $ftpConn, $ftppath"."$file, ".dirname(__FILE__)."/nullfile".", FTP_BINARY) returned FALSE => return FALSE -->\n";
  			return FALSE;
  		} else {
  			echo "\n<!-- -sl_fopen_ftp ftp_put( $ftpConn, $ftppath"."$file, ".dirname(__FILE__)."/nullfile".", FTP_BINARY) returned TRUE -->\n";
      	if( ftp_site( $ftpConn, "CHMOD 0666 $ftppath"."$file" ) === FALSE ) {
      		echo "\n<!-- -sl_fopen_ftp ftp_site( $ftpConn, \"CHMOD 0666 $ftppath"."$file\" ) returned FALSE => return FALSE ) -->\n";
      		return FALSE;
      	}	else {
      		echo "\n<!-- -sl_fopen_ftp ftp_site( $ftpConn, \"CHMOD 0666 $ftppath"."$file\" ) returned TRUE => return TRUE ) -->\n";
      	}	
	 		}
  	}
  }
  $ret = @fopen( $file, $mode );
  if( $ret === FALSE ) 
  	echo "\n<!-- -sl_fopen_ftp @fopen( $file, $mode ) returned FALSE => return FALSE; -->\n";
  else
  	echo "\n<!-- -sl_fopen_ftp @fopen( $file, $mode ) returned $ret => return $ret -->\n";
  return $ret;
}

/** CGI Implementation **/

function sl_upload_cgi( $srcFile, $dstFile ) {
	global $url;
	$ch = curl_init();

  curl_setopt($ch, CURLOPT_URL, $url."testcgi.sh?fname=".$dstFile);
  curl_setopt($ch, CURLOPT_HEADER, 0);
  curl_exec($ch);
  curl_close($ch);
  
  $hfileSrc = fopen( $srcFile, "rb" );
  $hfileDst = fopen( $dstFile, "wb" );
  
  while (!feof($hfileSrc)) {
  	$buffer = fread($hfileSrc, 8192);
  	fwrite( $hfileDst, $buffer );
	}
  
  fclose( $hfileSrc );
  fclose( $hfileDst );
  return TRUE;
}

?>
