<?php
/*************************************************************************/
/* SPAGHETTILEARNING - E-Learning System                                 */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2004 by Emanuele Sandri (esandri@tiscali.it)  			 */
/*																		 */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/

/**
 * @module scorm_items_track.php
 *
 * @version $Id: scorm_items_track.php,v 1.1 2004/06/01 23:48:34 ema Exp $
 * @copyright 2004 
 **/
/*
 * Org1
 * 		Item1.1 -------------> Res1 -> Track20 [complete]
 *  	Item1.2 
 *  		Item1.2.1
 * 				Item1.2.1.1 -> Res2 -> Track21 [passed]
 * 				Item1.2.1.2 -> Res3 -> Track22 [failed]
 * 			Item1.2.2 -------> Res4 -> Track23 [incomplete]
 * 			Item1.2.3 -------> Res5 -> null [--]
 *  	Item1.3 -------------> Res6 -> null [--]
 * 
 * User50	
 * 
 * Org1 ---------------------> ItemTrack100 [Org1,        null, User50,    null,   incomplete ]
 * 		Item1.1 -------------> ItemTrack101	[Org1,     Item1.1, User50, Track20,     complete ]
 *  	Item1.2 -------------> ItemTrack102 [Org1,     Item1.2, User50,    null,   incomplete ]
 *  		Item1.2.1 -------> ItemTrack103 [Org1,   Item1.2.1, User50,    null,   incomplete ]
 * 				Item1.2.1.1 -> ItemTrack104 [Org1, Item1.2.1.1, User50, Track21,       passed ]
 * 				Item1.2.1.2 -> ItemTrack105 [Org1, Item1.2.1.2, User50, Track22,       failed ]
 * 			Item1.2.2 -------> ItemTrack106 [Org1,   Item1.2.2, User50, Track23,   incomplete ]
 * 			Item1.2.3 -------> ItemTrack107 [Org1,   Item1.2.3, User50,    null,    ab initio ]
 *  	Item1.3 -------------> ItemTrack108 [Org1,     Item1.3, User50,    null,    ab initio ]
 * 
 * At the first open of the organization we must create all needed records (only visible?)
 * All records must be initialized with status = ab initio
 * When a tracking change status we must recalculate the status of all parents
 */ 
 
 
require_once(dirname(__FILE__) . '/config.scorm.php');
require_once(dirname(__FILE__) . '/scorm_utils.php');

Class Scorm_ItemsTrack {
	var $dbconn;
	var $prefix;
	var $main_table;
	
	
	/**
	 * Scorm_ItemsTrack::Scorm_ItemsTrack()
	 * Constructor
	 * @param $connection connection to the database
	 * @param $prefix the prefix to prepend to all tables names
	 **/
	function Scorm_ItemsTrack( $connection, $prefix ) {
		$this->dbconn = $connection;
		$this->prefix = $prefix;
		$this->main_table = $prefix."_scorm_items_track";
	}
	
	function getTrackingScore( $idscorm_tracking ) {
		$query = "SELECT score_raw FROM ".$this->prefix."_scorm_tracking WHERE idscorm_tracking=".$idscorm_tracking;
		$rs = mysql_query($query, $this->dbconn) or die( "Scorm_ItemsTrack::getTrackingScore error in select [$query] ". mysql_error($this->dbconn) );
		list( $score ) = mysql_fetch_row($rs);
		return $score;
	}
	
	function getItemTrack( $userid, $idscorm_item, $idscorm_organization = null ) {
		if( $idscorm_item === null ) {
			$query = "SELECT idscorm_item_track, idscorm_item, idscorm_tracking, status, nChild, nChildCompleted, nDescendant, nDescendantCompleted"
					." FROM ".$this->main_table
					." WHERE idUser=".$userid
					." AND idscorm_item IS NULL"
					." AND idscorm_organization = $idscorm_organization";
		} else {
			$query = "SELECT idscorm_item_track, idscorm_item, idscorm_tracking, status, nChild, nChildCompleted, nDescendant, nDescendantCompleted"
					." FROM ".$this->main_table
					." WHERE idUser=".$userid
					." AND idscorm_item=".$idscorm_item;
		}
		$rs = mysql_query($query, $this->dbconn);
		if( $rs === FALSE ) 
			die( "Scorm_ItemsTrack::getItemsTrack error in select [$query] ". mysql_error($this->dbconn) );
		if( mysql_num_rows($rs) == 0 ) 
			return FALSE;
		return $rs;		
	}
	
	function setTracking( $idscorm_item_track, $idscorm_tracking ) {
		$query = "UPDATE ".$this->main_table
				." SET idscorm_tracking=".$idscorm_tracking
				." WHERE idscorm_item_track=".$idscorm_item_track;
		if( mysql_query($query,$this->dbconn) ) {
			return TRUE;
		} else {
			die( "Scorm_ItemsTrack::setTracking error in select [$query] ". mysql_error($this->dbconn) );
		}
	}
	/**
	 * Scorm_ItemsTrack::getChildItemTrack()
	 * Return a record set with items_track child of a $idscorm_item
	 * 
	 * @param $userid id of the user to search
	 * @param $idscorm_item id of the start item or null, 
	 * 			in this case idscorm_organization must be set
	 * @return all items childs of a specified item as a array of idscorm_item
	 * 			return FALSE in case of error
	 * 			return an empty array if there isn't no child items
	 **/
	function getChildItemTrack( $userid, $idscorm_item, $idscorm_organization = null ) {
		$items_array = $this->getChildItems( $idscorm_item, $idscorm_organization );
		if ($items_array === FALSE ) {
		    return FALSE;
		}
		if( count($items_array) > 0 ) {
			$query = "SELECT idscorm_item_track, idscorm_item, idscorm_tracking, status, nChild, nChildCompleted, nDescendant, nDescendantCompleted"
					." FROM ".$this->main_table
					." WHERE idUser=".$userid
					." AND idscorm_item IN (".implode(',', $items_array).")";
			$rs = mysql_query($query,$this->dbconn);
			return $rs;
		} else {
			return FALSE;
		}		
	}

	/**
	 * Scorm_ItemsTrack::getDescendantItemTrack()
	 * Return a record set with items_track descendant of a $idscorm_item
	 * 
	 * @param $userid id of the user to search
	 * @param $idscorm_item id of the start item or null, 
	 * 			in this case idscorm_organization must be set
	 * @return all items descendant of a specified item as a array of idscorm_item
	 * 			return FALSE in case of error
	 * 			return an empty array if there isn't no descendant items
	 **/
	function getDescendantItemTrack( $userid, $idscorm_item, $idscorm_organization = null ) {
		$items_array = $this->getDescendantItems( $idscorm_item, $idscorm_organization );
		if ($items_array === FALSE ) {
		    return FALSE;
		}
		if( count($items_array) > 0 ) {
			$query = "SELECT idscorm_item_track, idscorm_item, idscorm_tracking, status, nChild, nChildCompleted, nDescendant, nDescendantCompleted"
					." FROM ".$this->main_table
					." WHERE idUser=".$userid
					." AND idscorm_item IN (".implode(',', $items_array).")";
			$rs = mysql_query($query,$this->dbconn);
			return $rs;
		} else {
			return FALSE;
		}		
	}
		
	/**
	 * Scorm_ItemsTrack::getParentItemTrack()
	 * Return a record set with items_track parent of a $idscorm_item
	 * 
	 * @param $userid id of the user to search
	 * @param $idscorm_item id of the start item, 
	 * @return the record set from items_track of the parent of a specified item 
	 * 			return FALSE in case of error
	 * 			return an empty array if there isn't no child items
	 **/
	function getParentItemTrack( $userid, $idscorm_item ) {
		$items_array = $this->getParentItem( $idscorm_item );
		if ($items_array === FALSE ) {
		    return FALSE;
		}
		if( count($items_array) > 0 ) {
			$query = "SELECT idscorm_item_track, idscorm_item, idscorm_tracking, status, nChild, nChildCompleted, nDescendant, nDescendantCompleted"
					." FROM ".$this->main_table
					." WHERE idUser=".$userid;
			if( !isset($items_array[0]) || $items_array[0] === NULL ) {
				$query .= " AND idscorm_organization=".$items_array[1]
						 ." AND idscorm_item IS NULL";
			} else {
				$query .= " AND idscorm_item=".$items_array[0];
			}
					
			$rs = mysql_query($query,$this->dbconn);
			if( $rs === FALSE )
				die("Scorm_ItemsTrack::getParentItemTrack error in select [$query] ". mysql_error($this->dbconn));
			return $rs;
		} else {
			return FALSE;
		}		
	}
		
	/**
	 * Scorm_ItemsTrack::getParentItemTrack()
	 * Return a record set with items_track parent of a $idscorm_item
	 * 
	 * @param $userid id of the user to search
	 * @param $idscorm_item id of the start item, 
	 * @return the record set from items_track of the parent of a specified item 
	 * 			return FALSE in case of error
	 * 			return an empty array if there isn't no child items
	 **/
	function getSiblingsItemTrack( $userid, $idscorm_item ) {
		$items_array = $this->getSiblingsItems( $idscorm_item );
		if ($items_array === FALSE ) {
		    return FALSE;
		}
		if( count($items_array) > 0 ) {
			$query = "SELECT idscorm_item_track, idscorm_item, idscorm_tracking, status, nChild, nChildCompleted, nDescendant, nDescendantCompleted"
					." FROM ".$this->main_table
					." WHERE idUser=".$userid
					." AND idscorm_item IN (".implode(',', $items_array).")";
			$rs = mysql_query($query,$this->dbconn);
			return $rs;
		} else {
			return FALSE;
		}		
	}
			
	/**
	 * Scorm_ItemsTrack::getChildItems()
	 * Return all items childs of a specified item 
	 * @param $idscorm_item
	 * @return all items childs of a specified item as a array of idscorm_item
	 * 			return FALSE in case of error
	 * 			return an empty array if there isn't no child items
	 **/
	function getChildItems( $idscorm_item, $idscorm_organization = null ) {
		if( $idscorm_organization === null ) {
			$query = "SELECT idscorm_item FROM ".$this->prefix."_scorm_items WHERE idscorm_parentitem=".$idscorm_item;
		} else {
			$query = "SELECT idscorm_item FROM ".$this->prefix."_scorm_items"
					." WHERE idscorm_organization=".$idscorm_organization
					." AND idscorm_parentitem IS NULL";
		}
		$rs = mysql_query($query, $this->dbconn );
		if( $rs == FALSE ) {
			return FALSE;
		} 
		if ( mysql_num_rows($rs) == 0) {
			$result = array();
		    return $result;
		} else {
			$result = mysql_fetch_row($rs);
			return $result;
		}
	}
	
	/**
	 * Scorm_ItemsTrack::getDescendantItems()
	 * Generate an array tath contains all the idscorm_item descendant from a given 
	 * idscorm_item or idscorm_organization
	 * @param $idscorm_item id of the start item or null, 
	 * 			in this case idscorm_organization must be set
	 * @param $idscorm_organization id of the organization to be searched for idscorm_items
	 * @return An array with the idscorm_item of all the items descendant; 
	 * 			if error return FALSE; if there isn't no descendants items return an 
	 * 			empty array
	 **/
	function getDescendantItems( $idscorm_item, $idscorm_organization = null ) {
		$result = array();
		$childs = $this->getChildItems($idscorm_item, $idscorm_organization);
		if($childs !== FALSE) {
			foreach( $childs as $item ) {
				$tmpArr = $this->getDescendantItems($item);
				if( $tmpArr !== FALSE )
					$result = array_merge($result, $tmpArr);
			}
			
		} else {
			return FALSE;
		}
		return $result;
	}
	
	function getParentItem($idscorm_item) {
		$query = "SELECT idscorm_parentitem, idscorm_organization FROM ".$this->prefix."_scorm_items"
				." WHERE idscorm_item=".$idscorm_item;
		$rs = mysql_query($query,$this->dbconn);
		if( $rs === FALSE ) {
			$textOut = "Scorm_ItemsTrack::getParentItem error in select [$query] ". mysql_error($this->dbconn);
			soap__dbgOut( $textOut, 1 );
			die( $textOut );
		}			
				
		return mysql_fetch_row($rs);
	}
	
	function getSiblingsItems($idscorm_item) {
		$resultArray = $this->getParentItem($idscorm_item);
		if( $resultArray === FALSE )
			return FALSE;
		list($idscorm_parentitem, $idscorm_organization) = mysql_fetch_row($resultArray);
		if( $idscorm_parentitem != NULL ) 
			$idscorm_organization = NULL;
		
		return $this->getChildItems($idscorm_parentitem, $idscorm_organization);
	}
	
	function getItemsInfo( $idscorm_item, $idscorm_organization = null ) {
		if( $idscorm_organization != null ) {
			$query = "SELECT nChild, nDescendant "
					." FROM ".$this->prefix."_scorm_organizations"
					." WHERE idscorm_organization=".$idscorm_organization;
		} else {
			$query = "SELECT nChild, nDescendant "
					." FROM ".$this->prefix."_scorm_items"
					." WHERE idscorm_item=".$idscorm_item;			
		}
		$rs = mysql_query($query,$this->dbconn);
		if( $rs === FALSE ) 
			die("Scorm_ItemsTrack::getParentItem error in select [$query] ". mysql_error($this->dbconn));
		else
			return mysql_fetch_assoc($rs);
	}
	
	function createItemsTrak( $userid, $idscorm_organization ) {
		$query = "INSERT INTO ".$this->main_table
				." (idscorm_organization,idUser,status,nChild,nChildCompleted,nDescendant,nDescendantCompleted)"
				." SELECT $idscorm_organization,$userid,'not attempted',nChild,0,nDescendant,0"
				." FROM ".$this->prefix."_scorm_organizations"
				." WHERE idscorm_organization=".$idscorm_organization;
		$result = mysql_query($query, $this->dbconn);
		if($result === FALSE) {
			$textOut = "Scorm_ItemsTrack::createItemsTrak error in insert [$query] ". mysql_error($this->dbconn);
			soap__dbgOut( $textOut, 1 );
			die( $textOut );
		}
		
		$query = "INSERT INTO ".$this->main_table
				." (idscorm_organization,idscorm_item,idUser,status,nChild,nChildCompleted,nDescendant,nDescendantCompleted)"
				." SELECT $idscorm_organization,idscorm_item,$userid,'not attempted',nChild,0,nDescendant,0"
				." FROM ".$this->prefix."_scorm_items"
				." WHERE idscorm_organization=".$idscorm_organization
				." ORDER BY idscorm_item";
		$result = mysql_query($query, $this->dbconn);
		if($result === FALSE) {
			$textOut = "Scorm_ItemsTrack::createItemsTrak error in insert [$query] ". mysql_error($this->dbconn);
			soap__dbgOut( $textOut, 1 );
			die( $textOut );
		}
		return $result;
	}
	
	function setStatus( $userid, $idscorm_item, $status ) {
		$rs = $this->getItemTrack($userid, $idscorm_item);
		if( $rs === FALSE ) {
			$textOut = "Scorm_ItemsTrack::setStatus error:  getItemTrack return FALSE";
			soap__dbgOut( $textOut, 1 );
			die( $textOut );
		}
		$record = mysql_fetch_assoc($rs);
		if( strcmp($record['status'], $status) != 0 ) {
			$query = "UPDATE ".$this->main_table
					." SET status='$status'"
					." WHERE idscorm_item_track=".$record['idscorm_item_track'];

			if( mysql_query($query, $this->dbconn) === FALSE ) {
				$textOut = "Scorm_ItemsTrack::setStatus error in update [$query] ". mysql_error($this->dbconn);
				soap__dbgOut( $textOut, 1 );		
				die( $textOut );			
			}
			if( strcmp($status,'completed') == 0 || strcmp($status, 'passed') == 0 ) {
				$this->forwardCompleted($userid, $idscorm_item, TRUE);
			}
		}
	}
	
	function forwardCompleted( $userid, $idscorm_item, $isChild ) {
		$rs = $this->getParentItemTrack($userid, $idscorm_item);
		if( $rs === FALSE ) 
			return FALSE;
		$record = mysql_fetch_assoc($rs);
		
		$status = 'incomplete';
		if( $isChild ) {
			$record['nChildCompleted']++;
			$updates[] = "nChildCompleted=".$record['nChildCompleted'];
			
			if( $record['nChildCompleted'] >= $record['nChild'] ) {
				$status = 'completed';
				if( $record['nChildCompleted'] > $record['nChild'] ) { // is possible?
					$record['nChildCompleted'] = $record['nChild'];
				}
			}			
		}
		$record['nDescendantCompleted']++;
		if( $record['nDescendantCompleted'] > $record['nDescendant'] ) 
			$record['nDescendantCompleted'] = $record['nDescendant'];
		
		$updates[] = "nDescendantCompleted=".$record['nDescendantCompleted'];
		if( strcmp($status,$record['status']) != 0)
			$updates[] = "status='$status'";
		
		$query = "UPDATE ".$this->main_table
				." SET ".implode(', ', $updates)
				." WHERE idscorm_item_track=".$record['idscorm_item_track'];
		
		if( mysql_query($query, $this->dbconn) === FALSE ) {
			$textOut = "Scorm_ItemsTrack::forwardCompleted error in update [$query] ". mysql_error($this->dbconn);
			soap__dbgOut( $textOut, 1 );		
			die( $textOut );
		}
		if( isset($record['idscorm_item']) && $record['idscorm_item'] !== NULL ) {
			if( strcmp($status,'completed') == 0 || strcmp($status, 'passed') == 0 ) 
				$this->forwardCompleted($userid, $record['idscorm_item'], TRUE);
			else 
				$this->forwardCompleted($userid, $record['idscorm_item'], FALSE);
		}		
	}
	
}

?>