<?php
/*************************************************************************/
/* SPAGHETTILEARNING - E-Learning System                                 */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2004 by Emanuele Sandri (esandri@tiscali.it)  			 */
/*																		 */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/

/**
 * @module Module to handle scorm tracking of lessons
 * 
 * @version $Id: scorm_tracking.php,v 1.3 2004/07/30 15:00:40 ema Exp $
 * @copyright 2004
 */
 
require_once(dirname(__FILE__) . '/config.scorm.php');
require_once(dirname(__FILE__) . '/scorm_utils.php');

$direct_access_params['cmi.core.student_id'] 		= 'student_id';
$direct_access_params['cmi.core.student_name'] 		= 'student_name';
$direct_access_params['cmi.core.lesson_location'] 	= 'lesson_location';
$direct_access_params['cmi.core.credit'] 			= 'credit';
$direct_access_params['cmi.core.lesson_status'] 	= 'lesson_status';
$direct_access_params['cmi.core.entry'] 			= 'entry';
$direct_access_params['cmi.core.score.raw'] 		= 'score_raw';
$direct_access_params['cmi.core.score.max'] 		= 'score_max';
$direct_access_params['cmi.core.score.min'] 		= 'score_min';
$direct_access_params['cmi.core.total_time'] 		= 'total_time';
$direct_access_params['cmi.core.lesson_mode'] 		= 'lesson_mode';
$direct_access_params['cmi.core.exit'] 				= 'exit';
$direct_access_params['cmi.core.session_time'] 		= 'session_time';
$direct_access_params['cmi.suspend_data'] 			= 'suspend_data';
$direct_access_params['cmi.launch_data'] 			= 'launch_data';
$direct_access_params['cmi.comments'] 				= 'comments';
$direct_access_params['cmi.comments_from_lms'] 		= 'comments_from_lms';

/**
 * Scorm_Tracking
 * 
 * @package SCORM
 * @author Emanuele Sandri
 * @copyright Copyright (c) 2004
 * @version $Id: scorm_tracking.php,v 1.3 2004/07/30 15:00:40 ema Exp $
 * @access public
 **/
class Scorm_Tracking {
	var $iduser;
	var $idscormresource;
	var $idscormpackage;
	var $idtrack;
	var $dbconn;
	var $err_code = 0;
	var $err_text = "";
	var $xmldoc;

	var $tracktable = "scorm_tracking";

	/**
	 * Constructor of the Scorm_Tracking
	 * @param $userid
	 * @param $id if $userid is null => idscrom_tracking, 
	 * 			  if $id_isresid is true => idscrom_resource, 
	 * 			  else idsco from manifest
	 * @param $idscormpackage
	 * @param $connection
	 * @param $createonfile
	 */
	function Scorm_Tracking($userid, $id, $idscormpackage, $connection, $createonfail = true, $id_isresid = false)
	{
		global $prefix;
		$this->iduser = $userid;
		$this->idscormpackage = $idscormpackage;
		$this->dbconn = $connection; 
		$this->xmldoc = null;
		$this->tracktable = $prefix."_scorm_tracking";
		
		// Find the idtrack for this peer idsco, iduser
		//$query = "SELECT idscorm_tracking FROM $this->tracktable WHERE idscorm_resource = $this->idscoresource and idUser = $this->iduser";
		if( $userid === null ) {
			// scoid is idscorm_tracking
			$query = "SELECT idUser, idscorm_resource FROM ".$prefix."_scorm_tracking WHERE idscorm_tracking=".$id;
			$rs = mysql_query($query, $this->dbconn);
			if ($rs == false || mysql_num_rows($rs) == 0) {
				return false;
			}
			list($this->iduser, $this->idscormresource) = mysql_fetch_row($rs);
			$this->idtrack = $id;
			return true;
		}
		if( $id_isresid ) {
			$query = "SELECT tracking.idscorm_resource, tracking.idscorm_tracking"
					." FROM ".$prefix."_scorm_tracking tracking"
					." WHERE tracking.idscorm_resource=".$id
					." AND tracking.idUser=".$userid;
		} else {
			$query = "SELECT res.idscorm_resource, tracking.idscorm_tracking"
					." FROM ".$prefix."_scorm_resources res, ".$prefix."_scorm_tracking tracking"
					." WHERE res.idscorm_package = ". $idscormpackage
					." AND res.idsco = '". $id ."'"
					." AND tracking.idUser =". $userid
					." AND res.idscorm_resource = tracking.idscorm_resource";
		}
		//die($query);
		$rs = mysql_query($query, $this->dbconn);
		if( $rs == false ) {
			$this->setError(1, "Scorm_Tracking::Scorm_Tracking " . mysql_error($this->dbconn) . "[" .$query ."]");
			return false;
		}
		if ( mysql_num_rows($rs) == 0) {
			if ($createonfail) {
				// not found => create new track record
				if ($id_isresid) {
				    $this->idscoresource = $id;
				} else {
					// search for idscorm_resource
					$query = "SELECT idscorm_resource"
					." FROM ".$prefix."_scorm_resources"
					." WHERE idscorm_package = ". $idscormpackage
					." AND idsco = '". $id ."'";
					
					$rs = mysql_query($query, $this->dbconn);
					if( $rs == false || mysql_num_rows($rs) == 0 ) {
						$this->setError(1, "Scorm_Tracking::Scorm_Tracking " . mysql_error($this->dbconn) . "[" .$query ."]");
						return false;
					}
					list($this->idscoresource) = mysql_fetch_array($rs); 
				}
				$query = "INSERT INTO $this->tracktable "
				. "(idUser,idscorm_resource) VALUES ( $this->iduser, $this->idscoresource )";
				if (mysql_query($query, $this->dbconn)) {
					if (mysql_affected_rows($this->dbconn) == 1) {
						// get the id of the last insert = idscorm_tracking
						$this->idtrack = mysql_insert_id($this->dbconn);
					} else {
						$this->setError(1, "Scorm_Tracking::Scorm_Tracking " . mysql_error($this->dbconn) . "[" .$query ."]");
						return false;
					} 
				} else {
					$this->setError(1, "Scorm_Tracking::Scorm_Tracking " . mysql_error($this->dbconn) . "[" .$query ."]");
					return false;
				} 
			} else {
				$this->setError(1, "Scorm_Tracking::Scorm_Tracking " . mysql_error($this->dbconn) . "[" .$query ."]");
				return false;
			} 
		} else {
			list($this->idscormresource, $this->idtrack) = mysql_fetch_array($rs);
			mysql_free_result($rs);
		} 
		return true;
	} 

	function setError($ecode, $etext)
	{
		$this->err_code = $ecode;
		$this->err_text = $etext;
		soap__dbgOut("Scorm_Tracking::setError( $ecode, $etext);" );
	} 

	function getErrorCode()
	{
		return $this->err_code;
	} 
	function getErrorText()
	{
		return $this->err_text;
	} 

	function getXmlDoc()
	{
		if( $this->xmldoc != null )
			return $this->xmldoc;
			
		$rs = mysql_query("SELECT xmldata FROM $this->tracktable WHERE idscorm_tracking = $this->idtrack", $this->dbconn);
		if ($rs === false) {
			// set error and exit with false
			$this->setError(1, "Scorm_Tracking::getXmlDoc " . mysql_error($this->dbconn));
			return false;
		} 

		$data = mysql_fetch_row($rs);
		if (strlen($data[0]) == 0) {
			$this->xmldoc = domxml_new_doc('1.0');
			$this->precompileXmlDoc();
		} else {
			$this->xmldoc = domxml_open_mem(stripslashes($data[0]));
		} 
		return $this->xmldoc;
	} 

	function precompileXmlDoc() {
		$root = $this->xmldoc->create_element('trackobj');
		$root = $this->xmldoc->append_child($root);
		$root->set_attribute('iduser', $this->iduser);
		$root->set_attribute('idresource', $this->idscoresource);
		$this->setParam('cmi.core.student_id', $this->iduser, false, true);
	}
	
	function setXmlDoc(&$xmldoc)
	{
		$this->xmldoc = $xmldoc;
		$query = "UPDATE $this->tracktable SET "
		 . "xmldata = '" . addslashes($xmldoc->dump_mem(true)) . "' "
		 . "WHERE idscorm_tracking = $this->idtrack";
		if (mysql_query($query)) {
			if (mysql_affected_rows($this->dbconn) == 1) {
				return true;
			} else {
				if(	mysql_errno($this->dbconn) != 0 ) {
					$this->setError(1, "Scorm_Tracking::setXmlDoc " . mysql_error($this->dbconn));
					return false;
				} else 
					return true;
			} 
		} else {
			$this->setError(1, "Scorm_Tracking::setXmlDoc " . mysql_error($this->dbconn));
			return false;
		} 
	} 
	
	function getParam($parampath, $SCOAccessibility = true) {
		soap__dbgOut("+Scorm_Tracking::getParam($parampath, $SCOAccessibility)");
		$aelem = getElementsArrayTrackingTemplate($parampath);
		// if last element is false => signal error
		$last = $aelem[count($aelem)-1];
		soap__dbgOut(" last[1] = {$last[1]} ");
		if( $last[1] == false ) {
			switch( $last[0] ){
				case '_count':
					$this->setError(203, 'Element not an array. Cannot have count.');
					return false;
				break;
				case '_children':
					$this->setError(202, 'Element cannot have children');
					return false;
				break;
				default:
					$this->setError(201, 'Invalid argument error');
					return false;
				break;
			}
		} else {
			// if it is write only return error
			if( is_object($last[1]) 
			 && $last[1]->get_attribute('SCOAccessibility') == 'writeonly' 
			 && $SCOAccessibility ) {
				$this->setError(404, 'Element is write only');
				return false;
			}
		}
		
		if( is_object($last[1]) ) {
			soap__dbgOut(" try to get value from direct map in table");
			// try to get value from direct map in table
			$fieldMap = $last[1]->get_attribute('dbRef');
			if( strlen($fieldMap) > 0 ) {
				// extract value from the db
				$query = "SELECT $fieldMap FROM $this->tracktable WHERE idscorm_tracking = $this->idtrack";
				$rs = mysql_query( $query, $this->dbconn);
				if ($rs === false) {
					// set error and exit with false
					$this->setError(1, "Scorm_Tracking::getParam [$query] " . mysql_error($this->dbconn));
					return false;
				} else {
					list($value) = mysql_fetch_array($rs);
					return $value;
				}			
			}
			soap__dbgOut(" value not fount in table map => go ahead");
		}
		// navigate troughout elements of xmldoc
		if( $this->xmldoc == null )
			$this->getXmlDoc();
		$elem = $this->xmldoc->document_element();
		for( $i = 0; $i < count($aelem) && $elem; $i++ ) {
			$infotemplate = $aelem[$i];
			$elemtemplate = $infotemplate[1];
			soap__dbgOut(" analyze ". $infotemplate[0]);
			switch( $infotemplate[0] ) {
				case '_count': // not used jet. See default
					soap__dbgOut(" value is _count return it!");
					return count($elem->child_nodes());
				break;
				case '_children':
					$result = array();
					foreach( $aelem[$i-1][1]->child_nodes() as $node ) {
						if( $node->node_type() == XML_ELEMENT_NODE )
							$result[] = $node->tagname();
					}
					return implode(',', $result);
				break;
				default:
					if( $elemtemplate->get_attribute('item') == 'no' 
					 && $elemtemplate->get_attribute('index') == 'yes' ) {
						// we must search for indexed element (index is in $infotemplate[0] 
						soap__dbgOut(" getelementbynameattrib( " . $elem->tagname() .", ". $elemtemplate->tagname() .", 'index',". $infotemplate[0] .") ");
						if( $i < (count($aelem)-1) ) {
							// next element is _count ?
							if( $aelem[$i+1][0] == "_count" ) {
								return count($elem->get_elements_by_tagname ( $elemtemplate->tagname() ));
							} 
						}
							
						$elem = getelementbynameattrib($elem, $elemtemplate->tagname(), 'index', $infotemplate[0]);
					} else {
						// if element is terminal or nothing is not important now
						$elem = getelementbynameattrib($elem, $elemtemplate->tagname());
					}
				break;
			}
		}
		// if elem is null return empty string, the value is not initialized
		if( $elem ) {
			$textelem = $elem->first_child();
			if( !$textelem )
				return $elem->get_content();
			else
				return $textelem->get_content();
		} else {
			if( !is_object($last[1]) ) // is _count but not all path are been present now
				return "0";
			return "";
		}
	}
	
	function setParam($parampath, $paramval, $SCOAccessibility = true, $create = true)
	{
		soap__dbgOut( "+Scorm_Tracking::setParam($parampath, $paramval, $SCOAccessibility, $create)" );
		$aelem = getElementsArrayTrackingTemplate($parampath);
		// if last element is false => signal error
		$last = $aelem[count($aelem)-1];
		if( $last[1] == false ) {
			switch( $last[0] ){
				case '_count':
				case '_children':
				case 'version':
					$this->setError(402, 'Invalid set value, element is a keyword');
					return false;
				break;
				default:
					$this->setError(201, 'Invalid argument error');
					return false;
				break;
			}
		} else {
			// if it is read only return error
			if( is_object($last[1]) 
			 && $last[1]->get_attribute('SCOAccessibility') == 'readonly' 
			 && $SCOAccessibility ) {
				$this->setError(403, 'Element is read only');
				return false;
			}
		}

		// try to get value from direct map in table
		$fieldMap = $last[1]->get_attribute('dbRef');
		soap__dbgOut( " Scorm_Tracking::setParam found filedMap = $fieldMap" );

		if( strlen($fieldMap) > 0 ) {
			// set value to the db
			$query = "UPDATE $this->tracktable SET ";
			$dataType = $last[1]->get_attribute('DataType');
			if( $dataType == 'CMIIdentifier' || $dataType == 'CMIVocabulary'
				|| $dataType == 'CMITimespan' || strncmp($dataType, 'CMIString', 9) == 0 ) {
				$query .= "$fieldMap = '" . addslashes($paramval) . "' ";
			} else {
				$query .= "$fieldMap = " . $paramval . " ";
			}
	 		$query .= "WHERE idscorm_tracking = $this->idtrack";
			
			soap__dbgOut( " Scorm_Tracking::setParam query for update fieldMap = $query" );

			if (mysql_query($query, $this->dbconn)) {
				if (mysql_affected_rows($this->dbconn) == 1) {
					// return true;
					// We must also set the value in xmlData filed!
					soap__dbgOut( " Scorm_Tracking::setParam OK affected row = 1" );
				} else {
					// mysql return 0 also when $fieldMap is already $paramval
					soap__dbgOut( " Scorm_Tracking::setParam affected row != 1" );
					if( mysql_errno($this->dbconn) != 0 ) {
						soap__dbgOut( " Scorm_Tracking::setParam report Error" );
						$this->setError(1, "Scorm_Tracking::setParam 1 [ $query ] " . mysql_error($this->dbconn));
						return false;
					}
				} 
			} else {
				soap__dbgOut( " Scorm_Tracking::setParam report Error" );
				$this->setError(1, "Scorm_Tracking::setParam 2 [ $query ] " . mysql_error($this->dbconn));
				return false;
			} 
		}

		
		// navigate troughout elements of xmldoc
		if( $this->xmldoc == null ) 
			$this->getXmlDoc();
		$elem = $this->xmldoc->document_element();
		for( $i = 0; $i < count($aelem) && $elem; $i++ ) {
			$infotemplate = $aelem[$i];
			switch( $infotemplate[0] ) {
				case '_count':
				case '_children':
					$this->setError(402, 'Invalid set value, element is a keyword' );
					return false;
				break;
				default:
					$elemtemplate = $infotemplate[1];
					if( $elemtemplate->get_attribute('item') == 'no' 
					 && $elemtemplate->get_attribute('index') == 'yes' ) {
						// we must search for indexed element (index is in $infotemplate[0] 
						$newelem = getelementbynameattrib($elem, $elemtemplate->tagname(), 'index', $infotemplate[0]);
					} else {
						// if element is terminal or nothing is not important now
						$newelem = getelementbynameattrib($elem, $elemtemplate->tagname());
					}
					if( !$newelem && $create) {
						$newelem = $this->xmldoc->create_element($elemtemplate->tagname());
						if( $elemtemplate->get_attribute('index') == 'yes')
							$newelem->set_attribute('index',$infotemplate[0]);
						if( $elemtemplate->get_attribute('item') == 'yes') 
							$newelem->set_attribute('item', 'yes');
						else
							$newelem->set_attribute('item', 'no');
						$elem->append_child($newelem);
					} 
					$elem = $newelem;				
				break;
			}
		}
		// now $elem point to the element to set
		$textelem = $elem->first_child();
		if( !$textelem )
			$elem->set_content($paramval);
		else
			$textelem->set_content($paramval);
		$this->setXmlDoc($this->xmldoc);
		soap__dbgOut( "-Scorm_Tracking::setParam return true" );

		return true;
	} 
	
} 

?>
