<?php
/*************************************************************************/
/* SPAGHETTILEARNING - E-Learning System                                 */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2004 by Emanuele Sandri (esandri@tiscali.it)  			 */
/*																		 */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/

/**
 * 
 * @module soapserver.php
 * @version $Id: soaplms.php,v 1.4 2004/07/18 23:49:01 ema Exp $
 * @copyright 2004
 */
error_reporting(E_ALL ^ E_NOTICE);

require_once(dirname(__FILE__) . '/../../config.php' );
require_once(dirname(__FILE__) . '/scorm_tracking.php');
require_once(dirname(__FILE__) . '/scorm_items.php');
require_once(dirname(__FILE__) . '/config.scorm.php');
require_once(dirname(__FILE__) . '/scorm_items_track.php');
require_once(dirname(__FILE__) . '/../function/soap/SOAP/Server.php');

/**
 * SOAPLMS
 * 
 * @package SCORM
 * @author ema Emanuele Sandri
 * @copyright Copyright (c) 2004
 * @version $Id: soaplms.php,v 1.4 2004/07/18 23:49:01 ema Exp $
 * @access public
 **/
class SOAPLMS {
	var $__dispatch_map = array(); 

	// Required function by SOAP_Server
	function __dispatch($methodname)
	{
		soap__dbgOut($methodname);
		if (isset($this->__dispatch_map[$methodname]))
			return $this->__dispatch_map[$methodname];
		return null;
	} 
	// Constructor builds PEAR::SOAP Server
	function SOAPLMS ()
	{ 
		// Define the signature of the dispatch map
		$this->__dispatch_map['Finish'] =
		array('in' => array('userid' => 'string',
				'scoid' => 'string',
				'itemid' => 'string',
				'orgid' => 'string',
				'scormpackage' => 'string'),
			'out' => array('status' => 'string',
				'error' => 'string',
				'errorString' => 'string')
			);
		$this->__dispatch_map['GetValue'] =
		array('in' => array('userid' => 'string',
				'scoid' => 'string',
				'itemid' => 'string',
				'scormpackage' => 'string',
				'param' => 'string'),
			'out' => array('status' => 'string',
				'error' => 'string',
				'errorString' => 'string',
				'value' => 'string')
			);
		$this->__dispatch_map['SetValue'] =
		array('in' => array('userid' => 'string',
				'scoid' => 'string',
				'itemid' => 'string',
				'scormpackage' => 'string',
				'param' => 'string',
				'value' => 'string'
				),
			'out' => array('status' => 'string',
				'error' => 'string',
				'errorString' => 'string'
				)
			);
	} 

	function Finish($userid, $scoid, $itemid, $orgid, $scormpackage ) {
		soap__dbgOut("+Finish($userid, $scoid, $itemid, $orgid, $scormpackage)");
		
		$status = "success";
		$error = "";
		$errorString = "";
		$lesson_status = "";
		
		global $dbhost, $dbuname, $dbpass, $dbname, $prefix;
		$dbconn = mysql_connect($dbhost, $dbuname, $dbpass)
			or die("Error connecting to database " . mysql_error());
		mysql_select_db($dbname, $dbconn)
			or die("Error selecting the db " . mysql_error($dbconn));
		soap__dbgOut("before: Scorm_Tracking($userid, $scoid, $scormpackage, $dbconn);");
		
		$trackobj = new Scorm_Tracking($userid, $scoid, $scormpackage, $dbconn, true, true);
		if( $trackobj->getErrorCode() != 0 ) {
			soap__dbgOut("Finish error: ". $trackobj->getErrorText());
		}
		soap__dbgOut("Finish: evaluate cmi.core.lesson_status");
		if( $trackobj->getParam('cmi.core.credit', false) == 'credit' ) {
			$itemobj = new Scorm_Item( $itemid, false, $scormpackage, $dbconn, false );
			if( $itemobj ) {
				if( strlen($itemobj->adlcp_masteryscore) > 0 ) {
					if( $trackobj->getParam('cmi.core.score.raw', false) >= $itemobj->adlcp_masteryscore ) {
						$trackobj->setParam('cmi.core.lesson_status', 'passed', false, true);
						$lesson_status = 'passed';
						soap__dbgOut("Finish: set cmi.core.lesson_status=passed");
					} else {
						$trackobj->setParam('cmi.core.lesson_status', 'failed', false, true);
						$lesson_status = 'failed';
						soap__dbgOut("Finish: set cmi.core.lesson_status=failed");
					}
				}
			}
		}
		
		soap__dbgOut("Finish: evaluate cmi.core.entry");
		if( $trackobj->getParam('cmi.core.exit', false) == "suspend" ) {
			$trackobj->setParam('cmi.core.entry', 'resume', false, true);
		} else {
			$trackobj->setParam('cmi.core.entry', '', false, true);
		}

		soap__dbgOut("Finish: evaluate cmi.core.total_time");
		$sessTime = $trackobj->getParam('cmi.core.session_time', false);
		$totTime = $trackobj->getParam('cmi.core.total_time', false);
		if( strlen($sessTime) > 0 ) {
			$totTime = sumScormTime($sessTime,$totTime);
			$trackobj->setParam('cmi.core.total_time', $totTime, false, true);
		}
		if( strlen($lesson_status) == 0 ) 
			$lesson_status = $trackobj->getParam('cmi.core.lesson_status', false);
		$itemtrack = new Scorm_ItemsTrack($dbconn, $prefix);
		$itemtrack->setStatus($userid, $itemid, $lesson_status );
				
		$arr_result = array(new SOAP_Value('status', 'string', $status),
			new SOAP_Value('error', 'string', $error),
			new SOAP_Value('errorString', 'string', $errorString),
			);		
			
		soap__dbgOut("Finish return status = $status");
		return $arr_result;
	}
	
	function GetValue($userid, $scoid, $itemid, $scormpackage, $param) {
		//echo "<!-- SOAPLMS::GetValue( $userid, $scoid, $scormpackage, $param ) -->\n";
		soap__dbgOut("+GetValue($userid, $scoid, $scormpackage, $param)");
		global $dbhost, $dbuname, $dbpass, $dbname;
		$dbconn = mysql_connect($dbhost, $dbuname, $dbpass)
		or die("Error connecting to database " . mysql_error());
		mysql_select_db($dbname, $dbconn)
		or die("Error selecting the db " . mysql_error($dbconn));
		soap__dbgOut("before: Scorm_Tracking($userid, $scoid, $scormpackage, $dbconn);");
		$trackobj = new Scorm_Tracking($userid, $scoid, $scormpackage, $dbconn, true, true);
		soap__dbgOut("after: Scorm_Tracking($userid, $scoid, $scormpackage, $dbconn);");
		if( $trackobj->getErrorCode() != 0 ) {
			soap__dbgOut("Scorm_Tracking error: ". $trackobj->getErrorText());
		}
		if (($value = $trackobj->getParam($param)) === false) {
			soap__dbgOut("Scorm_Tracking getParam($param) return false");
			soap__dbgOut("Scorm_Tracking error: ". $trackobj->getErrorCode() ."\n".$trackobj->getErrorText());
			$status = "error";
			$error = $trackobj->getErrorCode();
			$errorString = $trackobj->getErrorText();
		} else {
			soap__dbgOut("Scorm_Tracking getParam($param) return $value");
			$status = "success";
			$error = "";
			$errorString = "";
		} 
		$arr_result = array(new SOAP_Value('status', 'string', $status),
			new SOAP_Value('error', 'string', $error),
			new SOAP_Value('errorString', 'string', $errorString),
			new SOAP_Value('value', 'string', $value)
			);
		//soap__dbgOut($arr_result);
        soap__dbgOut("-GetValue return status = $status, value = $value");
		return $arr_result;
	} 

	function SetValue($userid, $scoid, $itemid, $scormpackage, $param, $value)
	{
		global $dbhost, $dbuname, $dbpass, $dbname;
        soap__dbgOut("+SetValue($userid, $scoid, $itemid, $scormpackage, $param, $value)");
		$dbconn = mysql_connect($dbhost, $dbuname, $dbpass)
		or die("Error connecting to database " . mysql_error());
		mysql_select_db($dbname, $dbconn)
		or die("Error selecting the db " . mysql_error($dbconn));
		$trackobj = new Scorm_Tracking($userid, $scoid, $scormpackage, $dbconn, true, true);
		if (($trackobj->setParam($param, $value)) === false) {
		    soap__dbgOut("Scorm_Tracking setParam($param, $value) return false");
			soap__dbgOut("Scorm_Tracking error: ". $trackobj->getErrorCode() ."\n".$trackobj->getErrorText());
		    $status = "error";
			$error = $trackobj->getErrorCode();
			$errorString = $trackobj->getErrorText();
		} else {
			soap__dbgOut("Scorm_Tracking setParam($param, $value) return true");
			$status = "success";
			$error = "";
			$errorString = "";
		} 
		$arr_result = array(new SOAP_Value('status', 'string', $status),
			new SOAP_Value('error', 'string', $error),
			new SOAP_Value('errorString', 'string', $errorString)
			);
       soap__dbgOut("-SetValue return $status");
       return $arr_result;
	} 
} 

function err_handler($errno, $errstr, $errfile, $errline) {
	$fout = fopen("/tmp/soaperror.txt", "a");
	fwrite($fout, "error number $errno\n: $errstr\n file: $errfile\n line: $errline\n");
	fclose($fout);
}

$lms = new SOAPLMS;
// Switch off notices to all GET

// Instantiate PEAR::SOAP SOAP_Server
$soapServer = new SOAP_Server;
// Build the object map (using this instance) + add a namespace
$soapServer->addObjectMap($lms, 'urn:SOAPLMS');

soap__dbgOut("+Arequest");
if ( (isset($_GET['op']) && $_GET['op'] == 'scolms') 
  || (isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] == 'POST')) {
  	//echo "<!-- soapServer->service -->";
	// debug only
	//$fin = fopen("/tmp/request.txt", "r");
	//$strPost = fread( $fin, filesize("/tmp/request.txt") );
	//echo htmlspecialchars($strPost);
	//$GLOBALS['HTTP_RAW_POST_DATA'] = $strPost;
	//$_SERVER['REQUEST_METHOD'] = 'POST';
	//$soapServer->service($GLOBALS['HTTP_RAW_POST_DATA']);
	// To register input
	// $fout = fopen("/tmp/request.txt", "w");
	// fwrite($fout, $GLOBALS['HTTP_RAW_POST_DATA']);
	// fclose($fout);
	// set_error_handler ( "err_handler" );
	// Turn on the server
	//ob_end_clean();
	soap__dbgOut("+Soap server");
	$soapServer->service($GLOBALS['HTTP_RAW_POST_DATA']);
	soap__dbgOut("-Soap server");
	
} else if (isset($_GET['op']) && $_GET['op'] == 'scoload') {
	// Load sco!
	//  @todo test prerequisites
	soap__dbgOut("+Sco launcher: idscormpackage = ".$_GET['idscormpackage'].", scoid = ".$_GET['scoid'].", userid = ".$_GET['userid'].", itemid = ".$_GET['itemid']);

	global $dbhost, $dbuname, $dbpass, $dbname, $relurl, $prefix;
	$dbconn = mysql_connect($dbhost, $dbuname, $dbpass)
		or die("Error connecting to database " . mysql_error());
	mysql_select_db($dbname, $dbconn)
		or die("Error selecting the db " . mysql_error($dbconn));
/*
	query for tracking record based on 
	- userid: identifier of user
	- scoid: identifier of sco from imsmanifest
	- idscormpackage: identifier of content package from imsmanifest
	
	 
	 
	- userid: identifier of user
	- scoid: identifier of resource in db
 	- idscormpackage: identifier of content package from imsmanifest
 */	
 	// join 3 tables
	// 1) _scorm_package for path
	// 2) _scorm_resources for href and scormtype
	// 3) _scorm_tacking for isscorm_tracking
	$query = "SELECT cp.path, res.idscorm_resource, res.href, res.scormtype, track.idscorm_tracking"
			." FROM ".$prefix."_scorm_package cp, ".$prefix."_scorm_resources res, ".$prefix."_scorm_tracking track"
			." WHERE cp.idscorm_package = ". $_GET['idscormpackage']
			." AND res.idscorm_resource = ". $_GET['scoid'] 
			." AND track.idUser = ". $_GET['userid']
			." AND cp.idscorm_package = res.idscorm_package"
			." AND res.idscorm_resource = track.idscorm_resource";
	//die($query);
	//echo "\n<!-- Join 3 table query = $query -->";
	$result = mysql_query($query);
	if( $result === false ) 
		die( "Error on load sco: ". mysql_error() . "[ $query ]");
	if( mysql_num_rows($result) > 0 ) {
		// The record exist. The user as already see this sco.
		$trackobj = new Scorm_Tracking($_GET['userid'], $_GET['scoid'], $_GET['idscormpackage'], $dbconn, true, true);
		if( $trackobj->getErrorCode() != 0) {
			die( "record exist but error:". $trackobj->getErrorText() );
		}		
		list($scopath, $idres, $href, $scormtype) = mysql_fetch_array($result);
	} else {
		// The record don't exist. 
		$query = "SELECT cp.path, res.idscorm_resource, res.href, res.scormtype"
				." FROM ".$prefix."_scorm_package cp, ".$prefix."_scorm_resources res"
				." WHERE cp.idscorm_package = ". $_GET['idscormpackage']
				." AND res.idscorm_resource = ". $_GET['scoid'] 
				." AND cp.idscorm_package = res.idscorm_package";
		// die($query);	
		$result = mysql_query($query) or die("soaplms:scoload error [$query] ". mysql_error());
		list($scopath, $idres, $href, $scormtype) = mysql_fetch_array($result);
		
		$trackobj = new Scorm_Tracking($_GET['userid'], $_GET['scoid'], $_GET['idscormpackage'], $dbconn, true, true);
		if( $trackobj->getErrorCode() != 0) {
			die( "record don't exist but error:". $trackobj->getErrorText() );
		}
		list($adlcp_masteryscore,$adlcp_maxtimeallowed,$adlcp_timelimitaction ) = 
			mysql_fetch_row(mysql_query( "SELECT adlcp_masteryscore,adlcp_maxtimeallowed,adlcp_timelimitaction"
										." FROM learning_scorm_items"
										." WHERE idscorm_item=".$_GET['itemid'] ));
		// tracking initializations
		if( $scormtype == 'sco' ) 
			$trackobj->setParam('cmi.core.lesson_status', 'not attempted', false, true);
		else
			$trackobj->setParam('cmi.core.lesson_status', 'completed', false, true);
			
		if( $trackobj->getErrorCode() != 0) {
			die( "setParam error:". $trackobj->getErrorText() );
		}
			// -- already set by precompileXmlDoc in ScromTraking object
		// $trackobj->setParam('cmi.core.student_id', $sal_getUserId(), false, true);
		$trackobj->setParam('cmi.core.student_name', $sal_getUserName(), false, true);
		$trackobj->setParam('cmi.core.credit', 'credit', false, true);
		$trackobj->setParam('cmi.core.lesson_mode', 'normal', false, true);
		$trackobj->setParam('cmi.core.entry', 'ab-initio', false, true);
		$trackobj->setParam('cmi.core.total_time', '0000:00:00.00', false, true);
		$trackobj->setParam('cmi.student_data.mastery_score', $adlcp_masteryscore, false, true);
		$trackobj->setParam('cmi.student_data.max_time_allowed', $adlcp_maxtimeallowed, false, true);
		$trackobj->setParam('cmi.student_data.time_limit_action', $adlcp_timelimitaction, false, true);
		$itemtrack = new Scorm_ItemsTrack($dbconn, $prefix);
		$rsItemTrack = $itemtrack->getItemTrack($_GET['userid'],$_GET['itemid']);
		if( $rsItemTrack === FALSE ) {
			// The first time for this user in this organization
			$itemtrack->createItemsTrak($_GET['userid'],$_GET['orgid']);
			// Now should be present
			$rsItemTrack = $itemtrack->getItemTrack($_GET['userid'],$_GET['itemid']);
		}
		$itArray = mysql_fetch_assoc($rsItemTrack);
		$itemtrack->setTracking($itArray['idscorm_item_track'],$trackobj->idtrack);
		if( $scormtype == 'asset' )
			$itemtrack->setStatus($_GET['userid'], $_GET['itemid'], 'completed' );
	}
		
	header("Location: $url"."$scopath/$href");
} else {
	// Deal with WSDL / Disco here
	require_once 'SOAP/Disco.php'; 
	// Create the Disco server
	$disco = new SOAP_DISCO_Server($soapServer, 'SOAPLMS');
	header("Content-type: text/xml");
	if (isset($_SERVER['QUERY_STRING']) &&
			strcasecmp($_SERVER['QUERY_STRING'], 'wsdl') == 0) {
		echo $disco->getWSDL(); // if we're talking http://www.example.com/index.php?wsdl
	} else {
		echo $disco->getDISCO();
	} 
	exit;
} 

?>
